# Generate a billing preview Generates a preview of future invoice items for one customer account. Use the BillingPreview call to calculate how much a single customer will be invoiced from the most recent invoice to a specific end of term date in the future. Additionally, you can use the BillingPreview service to access real-time data on an individual customer's usage consumption. The BillingPreview call only calculates taxes for charges in the subscription if you use Zuora Tax and the product rate plan charge associated with the invoice item uses the tax inclusive mode; otherwise, this call does not calculate taxes. If you have the Invoice Settlement feature enabled, you can also generate a preview of future credit memo items for one customer account. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Endpoint: POST /v1/operations/billing-preview Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Idempotency-Key` (string) Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident. - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) The minor API version. For a list of available minor versions, see API upgrades. ## Request fields (application/json): - `accountId` (string) The ID of the customer account to which the billing preview applies. Note: When posting billing preview, you must specify either accountId or accountNumber in the request body. Example: "8ad09bce83f1da020183f97e245c1c47" - `accountNumber` (string) The number of the customer account to which the billing preview applies. Note: When posting billing preview, you must specify either accountId or accountNumber in the request body. - `assumeRenewal` (string) Indicates whether to generate a preview of future invoice items and credit memo items with the assumption that the subscriptions are renewed. Set one of the following values in this field to decide how the assumption is applied in the billing preview. * All: The assumption is applied to all the subscriptions. Zuora generates preview invoice item data and credit memo item data from the first day of the customer's next billing period to the target date. * None: (Default) The assumption is not applied to the subscriptions. Zuora generates preview invoice item data and credit memo item data based on the current term end date and the target date. * If the target date is later than the current term end date, Zuora generates preview invoice item data and credit memo item data from the first day of the customer's next billing period to the current term end date. * If the target date is earlier than the current term end date, Zuora generates preview invoice item data and credit memo item data from the first day of the customer's next billing period to the target date. * Autorenew: The assumption is applied to the subscriptions that have auto-renew enabled. Zuora generates preview invoice item data and credit memo item data from the first day of the customer's next billing period to the target date. Note: - This field can only be used if the subscription renewal term is not set to 0. - The credit memo item data is only available if you have Invoice Settlement feature enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. - `chargeTypeToExclude` (string) The charge types to exclude from the billing preview. Possible values: OneTime, Recurring, Usage, and any combination of these values. - `includingDraftItems` (boolean) Whether draft document items are included in the billing preview run. By default, draft document items are not included. This field loads draft invoice items and credit memo items. The chargeTypeToExclude, targetDate, includingEvergreenSubscription, and assumeRenewal fields do not affect the behavior of the includingDraftItems field. - `includingEvergreenSubscription` (boolean) Indicates if evergreen subscriptions are included in the billingPreview call. - `targetDate` (string, required) The target date for the billingPreview call. The billingPreview call generates preview invoice item data and credit memo item data from the first day of the customer's next billing period to the TargetDate. If the TargetDate is later than the subscription current term end date, the preview invoice item data and credit memo item data is generated from the first day of the customer's next billing period to the current term end date. If you want to generate preview invoice item data and credit memo item data past the end of the subscription current term, specify the AssumeRenewal field in the request. Note: The credit memo item data is only available if you have Invoice Settlement feature enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. Example: "2024-09-30" ## Response 200 fields (application/json): - `accountId` (string) ID of the customer account to which the billing preview applies. - `creditMemoItems` (array) An array of credit memo items returned as the result of the billing preivew request. Note: The credit memo items are only available if you have Invoice Settlement feature enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. - `creditMemoItems.amount` (number) The amount of the credit memo item. For tax-inclusive credit memo items, the amount indicates the credit memo item amount including tax. For tax-exclusive credit memo items, the amount indicates the credit memo item amount excluding tax - `creditMemoItems.amountWithoutTax` (number) The credit memo item amount excluding tax. - `creditMemoItems.appliedToItemId` (string,null) The unique ID of the credit memo item that the discount charge is applied to. - `creditMemoItems.chargeDate` (string) The date when the credit memo item is created. - `creditMemoItems.chargeNumber` (string) Number of the charge. - `creditMemoItems.chargeType` (string) The type of charge. Possible values are OneTime, Recurring, and Usage. - `creditMemoItems.comment` (string) Comment of the credit memo item. - `creditMemoItems.id` (string) Credit memo item id. - `creditMemoItems.numberOfDeliveries` (number) The number of deliveries dedicated to the Delivery Pricing charges. Note: This field is available only if you have the Delivery Pricing feature enabled. - `creditMemoItems.processingType` (string) Identifies the kind of charge. Possible values: * charge * discount * prepayment * tax - `creditMemoItems.quantity` (string) Quantity of this item, in the configured unit of measure for the charge. - `creditMemoItems.ratePlanChargeId` (string) Id of the rate plan charge associated with this item. - `creditMemoItems.serviceEndDate` (string) End date of the service period for this item, i.e., the last day of the service period, in yyyy-mm-dd format. - `creditMemoItems.serviceStartDate` (string) Start date of the service period for this item, in yyyy-mm-dd format. If the charge is a one-time fee, this is the date of that charge. - `creditMemoItems.sku` (string) Unique SKU for the product associated with this item. - `creditMemoItems.skuName` (string) Name of the unique SKU for the product associated with this item. - `creditMemoItems.subscriptionId` (string) ID of the subscription associated with this item. - `creditMemoItems.subscriptionNumber` (string) Name of the subscription associated with this item. - `creditMemoItems.unitOfMeasure` (string) Unit used to measure consumption. - `invoiceItems` (array) An array of invoice items returned as the result of the billing preview request. - `invoiceItems.appliedToItemId` (string,null) The unique ID of the invoice item that the discount charge is applied to. - `invoiceItems.chargeAmount` (string) The amount of the charge. This amount doesn't include taxes regardless if the charge's tax mode is inclusive or exclusive. - `invoiceItems.chargeDate` (string) The date when the invoice item was created. - `invoiceItems.chargeDescription` (string) Description of the charge. - `invoiceItems.chargeId` (string) Id of the charge. - `invoiceItems.chargeName` (string) Name of the charge. - `invoiceItems.id` (string) Invoice item ID. - `invoiceItems.productName` (string) Name of the product associated with this item. - `invoiceItems.subscriptionName` (string) Name of the subscription associated with this item. - `invoiceItems.subscriptionNumber` (string) Number of the subscription associated with this item. - `invoiceItems.taxAmount` (string) If you use [Zuora Tax](https://knowledgecenter.zuora.com/Billing/Taxes/A_Zuora_Tax) and the product rate plan charge associated with the invoice item is of [tax inclusive mode](https://knowledgecenter.zuora.com/Billing/Taxes/A_Zuora_Tax/D_Associate_tax_codes_with_product_charges_and_set_the_tax_mode), the value of this field is the amount of tax applied to the charge. Otherwise, the value of this field is 0. - `success` (boolean) Returns true if the request was processed successfully. ## Response 500 fields (application/json): - `reasons` (array) Example: [{"code":"ObjectNotFound","message":"Notification definition with id 6e569e1e05f040eda51a927b140c0ac1 does not exist"}] - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response ## Response 4XX fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded.